submodule--helper init: set submodule.<name>.active
[git/git.git] / git-submodule.sh
CommitLineData
70c7ac22
LH
1#!/bin/sh
2#
4c8a9db6 3# git-submodule.sh: add, init, update or list git submodules
70c7ac22
LH
4#
5# Copyright (c) 2007 Lars Hjemli
6
1d5bec8b 7dashless=$(basename "$0" | sed -e 's/-/ /')
681b036f 8USAGE="[--quiet] add [-b <branch>] [-f|--force] [--name <name>] [--reference <repository>] [--] <repository> [<path>]
64b19ffe 9 or: $dashless [--quiet] status [--cached] [--recursive] [--] [<path>...]
1d5bec8b 10 or: $dashless [--quiet] init [--] [<path>...]
f6a52799 11 or: $dashless [--quiet] deinit [-f|--force] (--all| [--] <path>...)
abed000a 12 or: $dashless [--quiet] update [--init] [--remote] [-N|--no-fetch] [-f|--force] [--checkout|--merge|--rebase] [--[no-]recommend-shallow] [--reference <repository>] [--recursive] [--] [<path>...]
adc54235 13 or: $dashless [--quiet] summary [--cached|--files] [--summary-limit <n>] [commit] [--] [<path>...]
15fc56a8 14 or: $dashless [--quiet] foreach [--recursive] <command>
c32eaa8a
SB
15 or: $dashless [--quiet] sync [--recursive] [--] [<path>...]
16 or: $dashless [--quiet] absorbgitdirs [--] [<path>...]"
8f321a39 17OPTIONS_SPEC=
091a6eb0 18SUBDIRECTORY_OK=Yes
70c7ac22 19. git-sh-setup
98fcf840 20. git-parse-remote
70c7ac22 21require_work_tree
091a6eb0
JK
22wt_prefix=$(git rev-parse --show-prefix)
23cd_to_toplevel
70c7ac22 24
f1762d77
BW
25# Tell the rest of git that any URLs we get don't come
26# directly from the user, so it can apply policy as appropriate.
27GIT_PROTOCOL_FROM_USER=0
28export GIT_PROTOCOL_FROM_USER
33cfccbb 29
5c08dbbd 30command=
ecda0723 31branch=
d27b876b 32force=
d92a3959 33reference=
70c7ac22 34cached=
48bb3033
GP
35recursive=
36init=
1c244f6e 37files=
06b1abb5 38remote=
31ca3ac3 39nofetch=
32948425 40update=
15fc56a8 41prefix=
73b0898d 42custom_name=
275cd184 43depth=
72c5f883 44progress=
70c7ac22 45
be9d0a3a
HV
46die_if_unmatched ()
47{
48 if test "$1" = "#unmatched"
49 then
c4c02bf1 50 exit ${2:-1}
be9d0a3a
HV
51 fi
52}
53
88ce00c3
TK
54#
55# Print a submodule configuration setting
56#
57# $1 = submodule name
58# $2 = option name
59# $3 = default value
60#
61# Checks in the usual git-config places first (for overrides),
62# otherwise it falls back on .gitmodules. This allows you to
63# distribute project-wide defaults in .gitmodules, while still
64# customizing individual repositories if necessary. If the option is
65# not in .gitmodules either, print a default value.
66#
67get_submodule_config () {
68 name="$1"
69 option="$2"
70 default="$3"
71 value=$(git config submodule."$name"."$option")
72 if test -z "$value"
73 then
74 value=$(git config -f .gitmodules submodule."$name"."$option")
75 fi
76 printf '%s' "${value:-$default}"
77}
78
862ae6cd
RS
79isnumber()
80{
81 n=$(($1 + 0)) 2>/dev/null && test "$n" = "$1"
82}
83
14111fc4
JK
84# Sanitize the local git environment for use within a submodule. We
85# can't simply use clear_local_git_env since we want to preserve some
86# of the settings from GIT_CONFIG_PARAMETERS.
87sanitize_submodule_env()
88{
89044baa 89 save_config=$GIT_CONFIG_PARAMETERS
14111fc4 90 clear_local_git_env
89044baa 91 GIT_CONFIG_PARAMETERS=$save_config
860cba61 92 export GIT_CONFIG_PARAMETERS
14111fc4
JK
93}
94
ecda0723
SV
95#
96# Add a new submodule to the working tree, .gitmodules and the index
97#
ec05df35 98# $@ = repo path
ecda0723
SV
99#
100# optional branch is stored in global branch variable
101#
23a485e3 102cmd_add()
ecda0723 103{
5c08dbbd 104 # parse $args after "submodule ... add".
091a6eb0 105 reference_path=
5c08dbbd
JH
106 while test $# -ne 0
107 do
108 case "$1" in
109 -b | --branch)
110 case "$2" in '') usage ;; esac
111 branch=$2
112 shift
113 ;;
d27b876b
JL
114 -f | --force)
115 force=$1
116 ;;
5c08dbbd 117 -q|--quiet)
2e6a30ef 118 GIT_QUIET=1
5c08dbbd 119 ;;
d92a3959
MT
120 --reference)
121 case "$2" in '') usage ;; esac
091a6eb0 122 reference_path=$2
d92a3959
MT
123 shift
124 ;;
125 --reference=*)
091a6eb0 126 reference_path="${1#--reference=}"
d92a3959 127 ;;
73b0898d
JL
128 --name)
129 case "$2" in '') usage ;; esac
130 custom_name=$2
131 shift
132 ;;
275cd184
FG
133 --depth)
134 case "$2" in '') usage ;; esac
135 depth="--depth=$2"
136 shift
137 ;;
138 --depth=*)
139 depth=$1
140 ;;
5c08dbbd
JH
141 --)
142 shift
143 break
144 ;;
145 -*)
146 usage
147 ;;
148 *)
149 break
150 ;;
151 esac
152 shift
153 done
154
091a6eb0
JK
155 if test -n "$reference_path"
156 then
157 is_absolute_path "$reference_path" ||
158 reference_path="$wt_prefix$reference_path"
159
160 reference="--reference=$reference_path"
161 fi
162
ecda0723 163 repo=$1
64394e3a 164 sm_path=$2
ecda0723 165
64394e3a 166 if test -z "$sm_path"; then
6a066230 167 sm_path=$(printf '%s\n' "$repo" |
1414e578
JL
168 sed -e 's|/$||' -e 's|:*/*\.git$||' -e 's|.*[/:]||g')
169 fi
170
496eeeb1 171 if test -z "$repo" || test -z "$sm_path"; then
ecda0723
SV
172 usage
173 fi
174
091a6eb0
JK
175 is_absolute_path "$sm_path" || sm_path="$wt_prefix$sm_path"
176
ec05df35
ML
177 # assure repo is absolute or relative to parent
178 case "$repo" in
179 ./*|../*)
091a6eb0
JK
180 test -z "$wt_prefix" ||
181 die "$(gettext "Relative path can only be used from the toplevel of the working tree")"
182
ec05df35 183 # dereference source url relative to parent's url
63e95beb 184 realrepo=$(git submodule--helper resolve-relative-url "$repo") || exit
ec05df35
ML
185 ;;
186 *:*|/*)
187 # absolute url
188 realrepo=$repo
189 ;;
190 *)
497ee872 191 die "$(eval_gettext "repo URL: '\$repo' must be absolute or begin with ./|../")"
ec05df35
ML
192 ;;
193 esac
194
db75ada5
MG
195 # normalize path:
196 # multiple //; leading ./; /./; /../; trailing /
64394e3a 197 sm_path=$(printf '%s/\n' "$sm_path" |
db75ada5
MG
198 sed -e '
199 s|//*|/|g
200 s|^\(\./\)*||
8196e728 201 s|/\(\./\)*|/|g
db75ada5
MG
202 :start
203 s|\([^/]*\)/\.\./||
204 tstart
205 s|/*$||
206 ')
619acfc7
SB
207 if test -z "$force"
208 then
209 git ls-files --error-unmatch "$sm_path" > /dev/null 2>&1 &&
210 die "$(eval_gettext "'\$sm_path' already exists in the index")"
211 else
212 git ls-files -s "$sm_path" | sane_grep -v "^160000" > /dev/null 2>&1 &&
213 die "$(eval_gettext "'\$sm_path' already exists in the index and is not a submodule")"
214 fi
ecda0723 215
64394e3a 216 if test -z "$force" && ! git add --dry-run --ignore-missing "$sm_path" > /dev/null 2>&1
d27b876b 217 then
6ff875c5 218 eval_gettextln "The following path is ignored by one of your .gitignore files:
64394e3a 219\$sm_path
6ff875c5 220Use -f if you really want to add it." >&2
d27b876b
JL
221 exit 1
222 fi
223
73b0898d
JL
224 if test -n "$custom_name"
225 then
226 sm_name="$custom_name"
227 else
228 sm_name="$sm_path"
229 fi
230
d4264ca3 231 # perhaps the path exists and is already a git repo, else clone it
64394e3a 232 if test -e "$sm_path"
d4264ca3 233 then
496eeeb1 234 if test -d "$sm_path"/.git || test -f "$sm_path"/.git
d4264ca3 235 then
64394e3a 236 eval_gettextln "Adding existing repo at '\$sm_path' to the index"
d4264ca3 237 else
64394e3a 238 die "$(eval_gettext "'\$sm_path' already exists and is not a valid git repo")"
d4264ca3 239 fi
c2f93917 240
d4264ca3 241 else
4b7c286e
JL
242 if test -d ".git/modules/$sm_name"
243 then
244 if test -z "$force"
245 then
0d71dbfd 246 eval_gettextln >&2 "A git directory for '\$sm_name' is found locally with remote(s):"
4b7c286e 247 GIT_DIR=".git/modules/$sm_name" GIT_WORK_TREE=. git remote -v | grep '(fetch)' | sed -e s,^," ", -e s,' (fetch)',, >&2
0d71dbfd
VA
248 die "$(eval_gettextln "\
249If you want to reuse this local git directory instead of cloning again from
250 \$realrepo
251use the '--force' option. If the local git directory is not the correct repo
252or you are unsure what this means choose another name with the '--name' option.")"
4b7c286e 253 else
0d71dbfd 254 eval_gettextln "Reactivating local git directory for submodule '\$sm_name'."
4b7c286e
JL
255 fi
256 fi
d10e3b42 257 git submodule--helper clone ${GIT_QUIET:+--quiet} --prefix "$wt_prefix" --path "$sm_path" --name "$sm_name" --url "$realrepo" ${reference:+"$reference"} ${depth:+"$depth"} || exit
d851ffb9 258 (
14111fc4 259 sanitize_submodule_env
d851ffb9
JH
260 cd "$sm_path" &&
261 # ash fails to wordsplit ${branch:+-b "$branch"...}
262 case "$branch" in
263 '') git checkout -f -q ;;
264 ?*) git checkout -f -q -B "$branch" "origin/$branch" ;;
265 esac
266 ) || die "$(eval_gettext "Unable to checkout submodule '\$sm_path'")"
d4264ca3 267 fi
73b0898d 268 git config submodule."$sm_name".url "$realrepo"
d4264ca3 269
64394e3a
RJ
270 git add $force "$sm_path" ||
271 die "$(eval_gettext "Failed to add submodule '\$sm_path'")"
ecda0723 272
73b0898d
JL
273 git config -f .gitmodules submodule."$sm_name".path "$sm_path" &&
274 git config -f .gitmodules submodule."$sm_name".url "$repo" &&
b9289227
TK
275 if test -n "$branch"
276 then
277 git config -f .gitmodules submodule."$sm_name".branch "$branch"
278 fi &&
31991b02 279 git add --force .gitmodules ||
64394e3a 280 die "$(eval_gettext "Failed to register submodule '\$sm_path'")"
ecda0723
SV
281}
282
19a31f9c
ML
283#
284# Execute an arbitrary command sequence in each checked out
285# submodule
286#
287# $@ = command to execute
288#
289cmd_foreach()
290{
1d5bec8b
JH
291 # parse $args after "submodule ... foreach".
292 while test $# -ne 0
293 do
294 case "$1" in
295 -q|--quiet)
296 GIT_QUIET=1
297 ;;
15fc56a8
JH
298 --recursive)
299 recursive=1
300 ;;
1d5bec8b
JH
301 -*)
302 usage
303 ;;
304 *)
305 break
306 ;;
307 esac
308 shift
309 done
310
f030c96d
ÆAB
311 toplevel=$(pwd)
312
4dca1aa6
BC
313 # dup stdin so that it can be restored when running the external
314 # command in the subshell (and a recursive call to this function)
315 exec 3<&0
316
b0f4b408
SB
317 {
318 git submodule--helper list --prefix "$wt_prefix" ||
c4c02bf1 319 echo "#unmatched" $?
b0f4b408 320 } |
64394e3a 321 while read mode sha1 stage sm_path
19a31f9c 322 do
c4c02bf1 323 die_if_unmatched "$mode" "$sha1"
64394e3a 324 if test -e "$sm_path"/.git
19a31f9c 325 then
44431df0 326 displaypath=$(git submodule--helper relative-path "$prefix$sm_path" "$wt_prefix")
ea2fa104 327 say "$(eval_gettext "Entering '\$displaypath'")"
0ea306ef 328 name=$(git submodule--helper name "$sm_path")
15fc56a8 329 (
64394e3a 330 prefix="$prefix$sm_path/"
14111fc4 331 sanitize_submodule_env
64394e3a 332 cd "$sm_path" &&
44431df0 333 sm_path=$(git submodule--helper relative-path "$sm_path" "$wt_prefix") &&
091a6eb0
JK
334 # we make $path available to scripts ...
335 path=$sm_path &&
1c4fb136
AK
336 if test $# -eq 1
337 then
338 eval "$1"
339 else
340 "$@"
341 fi &&
15fc56a8
JH
342 if test -n "$recursive"
343 then
344 cmd_foreach "--recursive" "$@"
345 fi
4dca1aa6 346 ) <&3 3<&- ||
ea2fa104 347 die "$(eval_gettext "Stopping at '\$displaypath'; script returned non-zero status.")"
19a31f9c
ML
348 fi
349 done
350}
351
70c7ac22 352#
211b7f19 353# Register submodules in .git/config
70c7ac22
LH
354#
355# $@ = requested paths (default to all)
356#
23a485e3 357cmd_init()
70c7ac22 358{
5c08dbbd
JH
359 # parse $args after "submodule ... init".
360 while test $# -ne 0
361 do
362 case "$1" in
363 -q|--quiet)
2e6a30ef 364 GIT_QUIET=1
5c08dbbd
JH
365 ;;
366 --)
367 shift
368 break
369 ;;
370 -*)
371 usage
372 ;;
373 *)
374 break
375 ;;
376 esac
377 shift
378 done
379
6e7c14e6 380 git ${wt_prefix:+-C "$wt_prefix"} ${prefix:+--super-prefix "$prefix"} submodule--helper init ${GIT_QUIET:+--quiet} "$@"
70c7ac22
LH
381}
382
cf419828
JL
383#
384# Unregister submodules from .git/config and remove their work tree
385#
cf419828
JL
386cmd_deinit()
387{
388 # parse $args after "submodule ... deinit".
f6a52799 389 deinit_all=
cf419828
JL
390 while test $# -ne 0
391 do
392 case "$1" in
393 -f|--force)
394 force=$1
395 ;;
396 -q|--quiet)
397 GIT_QUIET=1
398 ;;
f6a52799
SB
399 --all)
400 deinit_all=t
401 ;;
cf419828
JL
402 --)
403 shift
404 break
405 ;;
406 -*)
407 usage
408 ;;
409 *)
410 break
411 ;;
412 esac
413 shift
414 done
415
f6a52799
SB
416 if test -n "$deinit_all" && test "$#" -ne 0
417 then
418 echo >&2 "$(eval_gettext "pathspec and --all are incompatible")"
419 usage
420 fi
421 if test $# = 0 && test -z "$deinit_all"
cf419828 422 then
f6a52799 423 die "$(eval_gettext "Use '--all' if you really want to deinitialize all submodules")"
cf419828
JL
424 fi
425
b0f4b408
SB
426 {
427 git submodule--helper list --prefix "$wt_prefix" "$@" ||
c4c02bf1 428 echo "#unmatched" $?
b0f4b408 429 } |
cf419828
JL
430 while read mode sha1 stage sm_path
431 do
c4c02bf1 432 die_if_unmatched "$mode" "$sha1"
0ea306ef 433 name=$(git submodule--helper name "$sm_path") || exit
cf419828 434
44431df0 435 displaypath=$(git submodule--helper relative-path "$sm_path" "$wt_prefix")
091a6eb0 436
cf419828
JL
437 # Remove the submodule work tree (unless the user already did it)
438 if test -d "$sm_path"
439 then
440 # Protect submodules containing a .git directory
441 if test -d "$sm_path/.git"
442 then
0d71dbfd
VA
443 die "$(eval_gettext "\
444Submodule work tree '\$displaypath' contains a .git directory
445(use 'rm -rf' if you really want to remove it including all of its history)")"
cf419828
JL
446 fi
447
448 if test -z "$force"
449 then
7b294bf4 450 git rm -qn "$sm_path" ||
091a6eb0 451 die "$(eval_gettext "Submodule work tree '\$displaypath' contains local modifications; use '-f' to discard them")"
cf419828 452 fi
7b294bf4 453 rm -rf "$sm_path" &&
091a6eb0
JK
454 say "$(eval_gettext "Cleared directory '\$displaypath'")" ||
455 say "$(eval_gettext "Could not remove submodule work tree '\$displaypath'")"
cf419828
JL
456 fi
457
091a6eb0 458 mkdir "$sm_path" || say "$(eval_gettext "Could not create empty submodule directory '\$displaypath'")"
cf419828
JL
459
460 # Remove the .git/config entries (unless the user already did it)
461 if test -n "$(git config --get-regexp submodule."$name\.")"
462 then
463 # Remove the whole section so we have a clean state when
464 # the user later decides to init this submodule again
465 url=$(git config submodule."$name".url)
466 git config --remove-section submodule."$name" 2>/dev/null &&
091a6eb0 467 say "$(eval_gettext "Submodule '\$name' (\$url) unregistered for path '\$displaypath'")"
cf419828
JL
468 fi
469 done
470}
471
fb43e31f 472is_tip_reachable () (
01e1d544 473 sanitize_submodule_env &&
fb43e31f
SB
474 cd "$1" &&
475 rev=$(git rev-list -n 1 "$2" --not --all 2>/dev/null) &&
476 test -z "$rev"
477)
478
479fetch_in_submodule () (
01e1d544 480 sanitize_submodule_env &&
fb43e31f
SB
481 cd "$1" &&
482 case "$2" in
483 '')
484 git fetch ;;
485 *)
6cbf454a
SB
486 shift
487 git fetch $(get_default_remote) "$@" ;;
fb43e31f
SB
488 esac
489)
490
70c7ac22 491#
211b7f19 492# Update each submodule path to correct revision, using clone and checkout as needed
70c7ac22
LH
493#
494# $@ = requested paths (default to all)
495#
23a485e3 496cmd_update()
70c7ac22 497{
5c08dbbd
JH
498 # parse $args after "submodule ... update".
499 while test $# -ne 0
500 do
501 case "$1" in
502 -q|--quiet)
2e6a30ef 503 GIT_QUIET=1
5c08dbbd 504 ;;
72c5f883
JK
505 --progress)
506 progress="--progress"
507 ;;
be4d2c83 508 -i|--init)
d92a3959 509 init=1
be4d2c83 510 ;;
06b1abb5
TK
511 --remote)
512 remote=1
513 ;;
31ca3ac3 514 -N|--no-fetch)
31ca3ac3
FF
515 nofetch=1
516 ;;
9db31bdf
NMC
517 -f|--force)
518 force=$1
519 ;;
ca2cedba 520 -r|--rebase)
32948425 521 update="rebase"
ca2cedba 522 ;;
d92a3959
MT
523 --reference)
524 case "$2" in '') usage ;; esac
525 reference="--reference=$2"
98dbe63d 526 shift
d92a3959
MT
527 ;;
528 --reference=*)
529 reference="$1"
d92a3959 530 ;;
42b49178 531 -m|--merge)
42b49178
JH
532 update="merge"
533 ;;
b13fd5c1 534 --recursive)
b13fd5c1
JH
535 recursive=1
536 ;;
efc5fb6a
JH
537 --checkout)
538 update="checkout"
539 ;;
abed000a
SB
540 --recommend-shallow)
541 recommend_shallow="--recommend-shallow"
542 ;;
543 --no-recommend-shallow)
544 recommend_shallow="--no-recommend-shallow"
545 ;;
275cd184
FG
546 --depth)
547 case "$2" in '') usage ;; esac
548 depth="--depth=$2"
549 shift
550 ;;
551 --depth=*)
552 depth=$1
553 ;;
2335b870
SB
554 -j|--jobs)
555 case "$2" in '') usage ;; esac
556 jobs="--jobs=$2"
557 shift
558 ;;
559 --jobs=*)
560 jobs=$1
561 ;;
5c08dbbd
JH
562 --)
563 shift
564 break
565 ;;
566 -*)
567 usage
568 ;;
569 *)
570 break
571 ;;
572 esac
98dbe63d 573 shift
5c08dbbd
JH
574 done
575
d92a3959
MT
576 if test -n "$init"
577 then
578 cmd_init "--" "$@" || return
579 fi
580
48308681
SB
581 {
582 git submodule--helper update-clone ${GIT_QUIET:+--quiet} \
72c5f883 583 ${progress:+"$progress"} \
48308681
SB
584 ${wt_prefix:+--prefix "$wt_prefix"} \
585 ${prefix:+--recursive-prefix "$prefix"} \
586 ${update:+--update "$update"} \
5f50f33e 587 ${reference:+"$reference"} \
48308681 588 ${depth:+--depth "$depth"} \
abed000a 589 ${recommend_shallow:+"$recommend_shallow"} \
2335b870 590 ${jobs:+$jobs} \
c4c02bf1 591 "$@" || echo "#unmatched" $?
48308681 592 } | {
15ffb7cd 593 err=
48308681 594 while read mode sha1 stage just_cloned sm_path
70c7ac22 595 do
c4c02bf1 596 die_if_unmatched "$mode" "$sha1"
48308681 597
0ea306ef 598 name=$(git submodule--helper name "$sm_path") || exit
5be60078 599 url=$(git config submodule."$name".url)
efc5fb6a
JH
600 if ! test -z "$update"
601 then
602 update_module=$update
603 else
604 update_module=$(git config submodule."$name".update)
a2aed08b
TK
605 if test -z "$update_module"
606 then
607 update_module="checkout"
608 fi
efc5fb6a
JH
609 fi
610
44431df0 611 displaypath=$(git submodule--helper relative-path "$prefix$sm_path" "$wt_prefix")
091a6eb0 612
48308681 613 if test $just_cloned -eq 1
d851ffb9 614 then
bf2d8246 615 subsha1=
e7b37caf
SB
616 case "$update_module" in
617 merge | rebase | none)
618 update_module=checkout ;;
619 esac
bf2d8246 620 else
14111fc4 621 subsha1=$(sanitize_submodule_env; cd "$sm_path" &&
5be60078 622 git rev-parse --verify HEAD) ||
091a6eb0 623 die "$(eval_gettext "Unable to find current revision in submodule path '\$displaypath'")"
70c7ac22 624 fi
211b7f19 625
06b1abb5
TK
626 if test -n "$remote"
627 then
92bbe7cc 628 branch=$(git submodule--helper remote-branch "$sm_path")
06b1abb5
TK
629 if test -z "$nofetch"
630 then
631 # Fetch remote before determining tracking $sha1
6cbf454a 632 fetch_in_submodule "$sm_path" $depth ||
06b1abb5
TK
633 die "$(eval_gettext "Unable to fetch in submodule path '\$sm_path'")"
634 fi
14111fc4
JK
635 remote_name=$(sanitize_submodule_env; cd "$sm_path" && get_default_remote)
636 sha1=$(sanitize_submodule_env; cd "$sm_path" &&
06b1abb5 637 git rev-parse --verify "${remote_name}/${branch}") ||
c87302bf 638 die "$(eval_gettext "Unable to find current \${remote_name}/\${branch} revision in submodule path '\$sm_path'")"
06b1abb5
TK
639 fi
640
496eeeb1 641 if test "$subsha1" != "$sha1" || test -n "$force"
70c7ac22 642 then
9db31bdf
NMC
643 subforce=$force
644 # If we don't already have a -f flag and the submodule has never been checked out
496eeeb1 645 if test -z "$subsha1" && test -z "$force"
b9b378a0 646 then
9db31bdf 647 subforce="-f"
b9b378a0 648 fi
31ca3ac3
FF
649
650 if test -z "$nofetch"
651 then
e5f522d6
JL
652 # Run fetch only if $sha1 isn't present or it
653 # is not reachable from a ref.
fb43e31f 654 is_tip_reachable "$sm_path" "$sha1" ||
6cbf454a 655 fetch_in_submodule "$sm_path" $depth ||
091a6eb0 656 die "$(eval_gettext "Unable to fetch in submodule path '\$displaypath'")"
fb43e31f
SB
657
658 # Now we tried the usual fetch, but $sha1 may
659 # not be reachable from any of the refs
660 is_tip_reachable "$sm_path" "$sha1" ||
6cbf454a 661 fetch_in_submodule "$sm_path" $depth "$sha1" ||
c87302bf 662 die "$(eval_gettext "Fetched in submodule path '\$displaypath', but it did not contain \$sha1. Direct fetching of that commit failed.")"
31ca3ac3
FF
663 fi
664
877449c1 665 must_die_on_failure=
32948425 666 case "$update_module" in
a2aed08b
TK
667 checkout)
668 command="git checkout $subforce -q"
669 die_msg="$(eval_gettext "Unable to checkout '\$sha1' in submodule path '\$displaypath'")"
670 say_msg="$(eval_gettext "Submodule path '\$displaypath': checked out '\$sha1'")"
671 ;;
32948425
JH
672 rebase)
673 command="git rebase"
091a6eb0
JK
674 die_msg="$(eval_gettext "Unable to rebase '\$sha1' in submodule path '\$displaypath'")"
675 say_msg="$(eval_gettext "Submodule path '\$displaypath': rebased into '\$sha1'")"
877449c1 676 must_die_on_failure=yes
32948425 677 ;;
42b49178
JH
678 merge)
679 command="git merge"
091a6eb0
JK
680 die_msg="$(eval_gettext "Unable to merge '\$sha1' in submodule path '\$displaypath'")"
681 say_msg="$(eval_gettext "Submodule path '\$displaypath': merged in '\$sha1'")"
877449c1 682 must_die_on_failure=yes
42b49178 683 ;;
6cb5728c
CP
684 !*)
685 command="${update_module#!}"
b08238ac
SB
686 die_msg="$(eval_gettext "Execution of '\$command \$sha1' failed in submodule path '\$displaypath'")"
687 say_msg="$(eval_gettext "Submodule path '\$displaypath': '\$command \$sha1'")"
6cb5728c
CP
688 must_die_on_failure=yes
689 ;;
32948425 690 *)
a2aed08b 691 die "$(eval_gettext "Invalid update mode '$update_module' for submodule '$name'")"
32948425 692 esac
70c7ac22 693
14111fc4 694 if (sanitize_submodule_env; cd "$sm_path" && $command "$sha1")
15ffb7cd 695 then
ff968f03 696 say "$say_msg"
877449c1
JH
697 elif test -n "$must_die_on_failure"
698 then
ff968f03 699 die_with_status 2 "$die_msg"
15ffb7cd 700 else
ff968f03 701 err="${err};$die_msg"
877449c1 702 continue
15ffb7cd 703 fi
70c7ac22 704 fi
b13fd5c1
JH
705
706 if test -n "$recursive"
707 then
75bf5e60 708 (
44431df0 709 prefix=$(git submodule--helper relative-path "$prefix$sm_path/" "$wt_prefix")
3604242f 710 wt_prefix=
14111fc4 711 sanitize_submodule_env
75bf5e60 712 cd "$sm_path" &&
36141282 713 eval cmd_update
75bf5e60 714 )
15ffb7cd
FG
715 res=$?
716 if test $res -gt 0
717 then
091a6eb0 718 die_msg="$(eval_gettext "Failed to recurse into submodule path '\$displaypath'")"
bb9d91b4 719 if test $res -ne 2
15ffb7cd 720 then
ff968f03 721 err="${err};$die_msg"
15ffb7cd
FG
722 continue
723 else
ff968f03 724 die_with_status $res "$die_msg"
15ffb7cd
FG
725 fi
726 fi
b13fd5c1 727 fi
70c7ac22 728 done
15ffb7cd
FG
729
730 if test -n "$err"
731 then
732 OIFS=$IFS
733 IFS=';'
734 for e in $err
735 do
736 if test -n "$e"
737 then
738 echo >&2 "$e"
739 fi
740 done
741 IFS=$OIFS
742 exit 1
743 fi
744 }
70c7ac22
LH
745}
746
bffe71f4
EM
747set_name_rev () {
748 revname=$( (
14111fc4 749 sanitize_submodule_env
bffe71f4 750 cd "$1" && {
5be60078
JH
751 git describe "$2" 2>/dev/null ||
752 git describe --tags "$2" 2>/dev/null ||
f669ac0b
ML
753 git describe --contains "$2" 2>/dev/null ||
754 git describe --all --always "$2"
bffe71f4
EM
755 }
756 ) )
757 test -z "$revname" || revname=" ($revname)"
758}
28f9af5d
PY
759#
760# Show commit summary for submodules in index or working tree
761#
762# If '--cached' is given, show summary between index and given commit,
763# or between working tree and given commit
764#
765# $@ = [commit (default 'HEAD'),] requested paths (default all)
766#
767cmd_summary() {
f2dc06a3 768 summary_limit=-1
d0f64dd4 769 for_status=
1c244f6e 770 diff_cmd=diff-index
f2dc06a3 771
28f9af5d
PY
772 # parse $args after "submodule ... summary".
773 while test $# -ne 0
774 do
775 case "$1" in
776 --cached)
777 cached="$1"
778 ;;
1c244f6e
JL
779 --files)
780 files="$1"
781 ;;
d0f64dd4
PY
782 --for-status)
783 for_status="$1"
784 ;;
f2dc06a3 785 -n|--summary-limit)
862ae6cd
RS
786 summary_limit="$2"
787 isnumber "$summary_limit" || usage
f2dc06a3
PY
788 shift
789 ;;
862ae6cd
RS
790 --summary-limit=*)
791 summary_limit="${1#--summary-limit=}"
792 isnumber "$summary_limit" || usage
793 ;;
28f9af5d
PY
794 --)
795 shift
796 break
797 ;;
798 -*)
799 usage
800 ;;
801 *)
802 break
803 ;;
804 esac
805 shift
806 done
bffe71f4 807
f2dc06a3
PY
808 test $summary_limit = 0 && return
809
3deea89c 810 if rev=$(git rev-parse -q --verify --default HEAD ${1+"$1"})
28f9af5d
PY
811 then
812 head=$rev
caa9c3ca 813 test $# = 0 || shift
496eeeb1 814 elif test -z "$1" || test "$1" = "HEAD"
3deea89c 815 then
14e940d7
JH
816 # before the first commit: compare with an empty tree
817 head=$(git hash-object -w -t tree --stdin </dev/null)
2ea6c2c9 818 test -z "$1" || shift
28f9af5d 819 else
3deea89c 820 head="HEAD"
28f9af5d
PY
821 fi
822
1c244f6e
JL
823 if [ -n "$files" ]
824 then
825 test -n "$cached" &&
465d6a00 826 die "$(gettext "The --cached option cannot be used with the --files option")"
1c244f6e
JL
827 diff_cmd=diff-files
828 head=
829 fi
830
28f9af5d 831 cd_to_toplevel
091a6eb0 832 eval "set $(git rev-parse --sq --prefix "$wt_prefix" -- "$@")"
28f9af5d 833 # Get modified modules cared by user
18076502 834 modules=$(git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- "$@" |
e1622bfc 835 sane_egrep '^:([0-7]* )?160000' |
2be94509 836 while read mod_src mod_dst sha1_src sha1_dst status sm_path
28f9af5d
PY
837 do
838 # Always show modules deleted or type-changed (blob<->module)
496eeeb1
EP
839 if test "$status" = D || test "$status" = T
840 then
6a066230 841 printf '%s\n' "$sm_path"
496eeeb1
EP
842 continue
843 fi
927b26f8 844 # Respect the ignore setting for --for-status.
845 if test -n "$for_status"
846 then
0ea306ef 847 name=$(git submodule--helper name "$sm_path")
927b26f8 848 ignore_config=$(get_submodule_config "$name" ignore none)
496eeeb1 849 test $status != A && test $ignore_config = all && continue
927b26f8 850 fi
28f9af5d 851 # Also show added or modified modules which are checked out
2be94509 852 GIT_DIR="$sm_path/.git" git-rev-parse --git-dir >/dev/null 2>&1 &&
6a066230 853 printf '%s\n' "$sm_path"
28f9af5d
PY
854 done
855 )
1cb639e6 856
d0f64dd4
PY
857 test -z "$modules" && return
858
18076502 859 git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- $modules |
e1622bfc 860 sane_egrep '^:([0-7]* )?160000' |
1cb639e6
PY
861 cut -c2- |
862 while read mod_src mod_dst sha1_src sha1_dst status name
863 do
864 if test -z "$cached" &&
865 test $sha1_dst = 0000000000000000000000000000000000000000
866 then
867 case "$mod_dst" in
868 160000)
869 sha1_dst=$(GIT_DIR="$name/.git" git rev-parse HEAD)
870 ;;
871 100644 | 100755 | 120000)
872 sha1_dst=$(git hash-object $name)
873 ;;
874 000000)
875 ;; # removed
876 *)
877 # unexpected type
6ff875c5 878 eval_gettextln "unexpected mode \$mod_dst" >&2
1cb639e6
PY
879 continue ;;
880 esac
881 fi
882 missing_src=
883 missing_dst=
884
885 test $mod_src = 160000 &&
30353a40 886 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_src^0 >/dev/null &&
1cb639e6
PY
887 missing_src=t
888
889 test $mod_dst = 160000 &&
30353a40 890 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_dst^0 >/dev/null &&
1cb639e6 891 missing_dst=t
bffe71f4 892
44431df0 893 display_name=$(git submodule--helper relative-path "$name" "$wt_prefix")
091a6eb0 894
1cb639e6
PY
895 total_commits=
896 case "$missing_src,$missing_dst" in
897 t,)
091a6eb0 898 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commit \$sha1_src")"
1cb639e6
PY
899 ;;
900 ,t)
091a6eb0 901 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commit \$sha1_dst")"
1cb639e6
PY
902 ;;
903 t,t)
091a6eb0 904 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commits \$sha1_src and \$sha1_dst")"
1cb639e6
PY
905 ;;
906 *)
907 errmsg=
908 total_commits=$(
496eeeb1 909 if test $mod_src = 160000 && test $mod_dst = 160000
1cb639e6
PY
910 then
911 range="$sha1_src...$sha1_dst"
912 elif test $mod_src = 160000
913 then
914 range=$sha1_src
915 else
916 range=$sha1_dst
917 fi
918 GIT_DIR="$name/.git" \
b0e621ad 919 git rev-list --first-parent $range -- | wc -l
1cb639e6 920 )
eed35595 921 total_commits=" ($(($total_commits + 0)))"
1cb639e6
PY
922 ;;
923 esac
924
925 sha1_abbr_src=$(echo $sha1_src | cut -c1-7)
926 sha1_abbr_dst=$(echo $sha1_dst | cut -c1-7)
927 if test $status = T
928 then
b3e73449
ÆAB
929 blob="$(gettext "blob")"
930 submodule="$(gettext "submodule")"
1cb639e6
PY
931 if test $mod_dst = 160000
932 then
091a6eb0 933 echo "* $display_name $sha1_abbr_src($blob)->$sha1_abbr_dst($submodule)$total_commits:"
1cb639e6 934 else
091a6eb0 935 echo "* $display_name $sha1_abbr_src($submodule)->$sha1_abbr_dst($blob)$total_commits:"
1cb639e6
PY
936 fi
937 else
091a6eb0 938 echo "* $display_name $sha1_abbr_src...$sha1_abbr_dst$total_commits:"
1cb639e6
PY
939 fi
940 if test -n "$errmsg"
941 then
942 # Don't give error msg for modification whose dst is not submodule
943 # i.e. deleted or changed to blob
944 test $mod_dst = 160000 && echo "$errmsg"
945 else
496eeeb1 946 if test $mod_src = 160000 && test $mod_dst = 160000
1cb639e6 947 then
f2dc06a3
PY
948 limit=
949 test $summary_limit -gt 0 && limit="-$summary_limit"
1cb639e6 950 GIT_DIR="$name/.git" \
f2dc06a3 951 git log $limit --pretty='format: %m %s' \
1cb639e6
PY
952 --first-parent $sha1_src...$sha1_dst
953 elif test $mod_dst = 160000
954 then
955 GIT_DIR="$name/.git" \
956 git log --pretty='format: > %s' -1 $sha1_dst
957 else
958 GIT_DIR="$name/.git" \
959 git log --pretty='format: < %s' -1 $sha1_src
960 fi
961 echo
962 fi
963 echo
3ba7407b 964 done
28f9af5d 965}
70c7ac22 966#
941987a5 967# List all submodules, prefixed with:
70c7ac22
LH
968# - submodule not initialized
969# + different revision checked out
970#
971# If --cached was specified the revision in the index will be printed
972# instead of the currently checked out revision.
973#
974# $@ = requested paths (default to all)
975#
23a485e3 976cmd_status()
70c7ac22 977{
5c08dbbd
JH
978 # parse $args after "submodule ... status".
979 while test $# -ne 0
980 do
981 case "$1" in
982 -q|--quiet)
2e6a30ef 983 GIT_QUIET=1
5c08dbbd
JH
984 ;;
985 --cached)
986 cached=1
987 ;;
64b19ffe
JH
988 --recursive)
989 recursive=1
990 ;;
5c08dbbd
JH
991 --)
992 shift
993 break
994 ;;
995 -*)
996 usage
997 ;;
998 *)
999 break
1000 ;;
1001 esac
1002 shift
1003 done
1004
b0f4b408
SB
1005 {
1006 git submodule--helper list --prefix "$wt_prefix" "$@" ||
c4c02bf1 1007 echo "#unmatched" $?
b0f4b408 1008 } |
64394e3a 1009 while read mode sha1 stage sm_path
70c7ac22 1010 do
c4c02bf1 1011 die_if_unmatched "$mode" "$sha1"
0ea306ef 1012 name=$(git submodule--helper name "$sm_path") || exit
44431df0 1013 displaypath=$(git submodule--helper relative-path "$prefix$sm_path" "$wt_prefix")
313ee0d6
NMC
1014 if test "$stage" = U
1015 then
1016 say "U$sha1 $displaypath"
1017 continue
1018 fi
6dc9f01f 1019 if ! git submodule--helper is-active "$sm_path" ||
496eeeb1
EP
1020 {
1021 ! test -d "$sm_path"/.git &&
1022 ! test -f "$sm_path"/.git
1023 }
70c7ac22 1024 then
64b19ffe 1025 say "-$sha1 $displaypath"
70c7ac22
LH
1026 continue;
1027 fi
64394e3a 1028 if git diff-files --ignore-submodules=dirty --quiet -- "$sm_path"
70c7ac22 1029 then
b545cd15 1030 set_name_rev "$sm_path" "$sha1"
64b19ffe 1031 say " $sha1 $displaypath$revname"
70c7ac22
LH
1032 else
1033 if test -z "$cached"
1034 then
14111fc4 1035 sha1=$(sanitize_submodule_env; cd "$sm_path" && git rev-parse --verify HEAD)
70c7ac22 1036 fi
b545cd15 1037 set_name_rev "$sm_path" "$sha1"
64b19ffe
JH
1038 say "+$sha1 $displaypath$revname"
1039 fi
1040
1041 if test -n "$recursive"
1042 then
1043 (
1044 prefix="$displaypath/"
14111fc4 1045 sanitize_submodule_env
10450cf7 1046 wt_prefix=
64394e3a 1047 cd "$sm_path" &&
e15bec0e 1048 eval cmd_status
64b19ffe 1049 ) ||
64394e3a 1050 die "$(eval_gettext "Failed to recurse into submodule path '\$sm_path'")"
70c7ac22
LH
1051 fi
1052 done
1053}
2327f61e
DA
1054#
1055# Sync remote urls for submodules
1056# This makes the value for remote.$remote.url match the value
1057# specified in .gitmodules.
1058#
1059cmd_sync()
1060{
1061 while test $# -ne 0
1062 do
1063 case "$1" in
1064 -q|--quiet)
2e6a30ef 1065 GIT_QUIET=1
2327f61e
DA
1066 shift
1067 ;;
82f49f29
PH
1068 --recursive)
1069 recursive=1
1070 shift
1071 ;;
2327f61e
DA
1072 --)
1073 shift
1074 break
1075 ;;
1076 -*)
1077 usage
1078 ;;
1079 *)
1080 break
1081 ;;
1082 esac
1083 done
1084 cd_to_toplevel
b0f4b408
SB
1085 {
1086 git submodule--helper list --prefix "$wt_prefix" "$@" ||
c4c02bf1 1087 echo "#unmatched" $?
b0f4b408 1088 } |
64394e3a 1089 while read mode sha1 stage sm_path
2327f61e 1090 do
c4c02bf1 1091 die_if_unmatched "$mode" "$sha1"
e7849a96
BW
1092
1093 # skip inactive submodules
25b31f1b 1094 if ! git submodule--helper is-active "$sm_path"
e7849a96
BW
1095 then
1096 continue
1097 fi
1098
25b31f1b 1099 name=$(git submodule--helper name "$sm_path")
2327f61e 1100 url=$(git config -f .gitmodules --get submodule."$name".url)
baede9f8
JH
1101
1102 # Possibly a url relative to parent
1103 case "$url" in
1104 ./*|../*)
967b2c66
JS
1105 # rewrite foo/bar as ../.. to find path from
1106 # submodule work tree to superproject work tree
6a066230 1107 up_path="$(printf '%s\n' "$sm_path" | sed "s/[^/][^/]*/../g")" &&
967b2c66
JS
1108 # guarantee a trailing /
1109 up_path=${up_path%/}/ &&
1110 # path from submodule work tree to submodule origin repo
63e95beb 1111 sub_origin_url=$(git submodule--helper resolve-relative-url "$url" "$up_path") &&
967b2c66 1112 # path from superproject work tree to submodule origin repo
63e95beb 1113 super_config_url=$(git submodule--helper resolve-relative-url "$url") || exit
967b2c66
JS
1114 ;;
1115 *)
1116 sub_origin_url="$url"
1117 super_config_url="$url"
baede9f8
JH
1118 ;;
1119 esac
1120
e7849a96
BW
1121 displaypath=$(git submodule--helper relative-path "$prefix$sm_path" "$wt_prefix")
1122 say "$(eval_gettext "Synchronizing submodule url for '\$displaypath'")"
1123 git config submodule."$name".url "$super_config_url"
1124
1125 if test -e "$sm_path"/.git
2327f61e 1126 then
e7849a96
BW
1127 (
1128 sanitize_submodule_env
1129 cd "$sm_path"
1130 remote=$(get_default_remote)
1131 git config remote."$remote".url "$sub_origin_url"
ccee6086 1132
e7849a96 1133 if test -n "$recursive"
ccee6086 1134 then
e7849a96
BW
1135 prefix="$prefix$sm_path/"
1136 eval cmd_sync
ccee6086 1137 fi
e7849a96 1138 )
2327f61e
DA
1139 fi
1140 done
1141}
70c7ac22 1142
f6f85861
SB
1143cmd_absorbgitdirs()
1144{
1145 git submodule--helper absorb-git-dirs --prefix "$wt_prefix" "$@"
1146}
1147
5c08dbbd
JH
1148# This loop parses the command line arguments to find the
1149# subcommand name to dispatch. Parsing of the subcommand specific
1150# options are primarily done by the subcommand implementations.
1151# Subcommand specific options such as --branch and --cached are
1152# parsed here as well, for backward compatibility.
1153
1154while test $# != 0 && test -z "$command"
70c7ac22
LH
1155do
1156 case "$1" in
f6f85861 1157 add | foreach | init | deinit | update | status | summary | sync | absorbgitdirs)
5c08dbbd 1158 command=$1
70c7ac22
LH
1159 ;;
1160 -q|--quiet)
2e6a30ef 1161 GIT_QUIET=1
70c7ac22 1162 ;;
ecda0723
SV
1163 -b|--branch)
1164 case "$2" in
1165 '')
1166 usage
1167 ;;
1168 esac
1169 branch="$2"; shift
1170 ;;
70c7ac22 1171 --cached)
28f9af5d 1172 cached="$1"
70c7ac22
LH
1173 ;;
1174 --)
1175 break
1176 ;;
1177 -*)
1178 usage
1179 ;;
1180 *)
1181 break
1182 ;;
1183 esac
1184 shift
1185done
1186
5c08dbbd 1187# No command word defaults to "status"
af9c9f97
RR
1188if test -z "$command"
1189then
1190 if test $# = 0
1191 then
1192 command=status
1193 else
1194 usage
1195 fi
1196fi
5c08dbbd
JH
1197
1198# "-b branch" is accepted only by "add"
1199if test -n "$branch" && test "$command" != add
1200then
ecda0723 1201 usage
5c08dbbd
JH
1202fi
1203
28f9af5d 1204# "--cached" is accepted only by "status" and "summary"
496eeeb1 1205if test -n "$cached" && test "$command" != status && test "$command" != summary
5c08dbbd 1206then
70c7ac22 1207 usage
5c08dbbd
JH
1208fi
1209
1210"cmd_$command" "$@"